[poj 3126]Prime Path 广搜
Prime Path
Time Limit : 2000/1000ms (Java/Other) Memory Limit : 131072/65536K (Java/Other)
Total Submission(s) : 6 Accepted Submission(s) : 6
Problem Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that 易做图. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0
Source
PKU
[cpp]
// 8.16.cpp : 定义控制台应用程序的入口点。
//
#include "stdafx.h"
#include<cstdio>
#include<queue>
#include<cstring>
#define MEM(arr,w) memset(arr,w,sizeof(arr))
#define MAX 10000
#define INF 0x3f3f3f3f
using namespace std;
int prime[MAX+2]={0};
int num[4];
int visit[MAX],step[MAX];
int st,ed,mint,ss,tt;
void Prime()
{
for(int i=2;i<MAX;i++)
{
if(!prime[i])
{
for(int j=i<<1;j<MAX;j+=i)
prime[j]=1;
}
}
}
void Init()
{
MEM(visit,false);
MEM(step,0);
mint=INF;
}
void BFS()
{
queue<int> Q;
Q.push(st);
visit[st]=true;
step[st]=0;
while(!Q.empty())
{
ss=Q.front();
Q.pop();
if(ss==ed) if(step[ss]<mint) mint=step[ss];
for(int i=0;i<4;i++)
{
num[0]=ss%10,num[1]=ss/10%10,num[2]=ss/100%10,num[3]=ss/1000;
for(int j=0;j<=9;j++)
{
num[i]=j;
tt=num[3]*1000+num[2]*100+num[1]*10+num[0];
if(!prime[tt]&&!visit[tt]&&tt>1000)
{
visit[tt]=true;
Q.push(tt);
step[tt]=step[ss]+1;
}
}
}
}
return ;
}
int main()
{
int T;
Prime();
scanf("%d",&T);
while(T--)
{
scanf("%d%d",&st,&ed);
Init();
BFS();
if(mint!=INF) printf("%d\n",mint);
else printf("Impossible\n");
}
return 0;
}
补充:软件开发 , C++ ,